VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsArrayList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'-----
' clsArrayList
'-----
' ArrayList class implementation of modArrayList
' Note: SDA
'-----
' Author:       Edmundo T. Mendiola
' Created:      04/12/2000
'-----

Option Explicit

' Sort mode valid values
Enum ArrayListSortMode
    alsNoSortMode = 0
    alsSortAscend = 1
    alsSortDescend = 2
End Enum

' Change event alcReason legal values
Enum ArrayListChangeReason
    alcClear = 0    ' Clear method is activated
    alcAdd = 1      ' AddItem method is activated
    alcInsert = 2   ' InsertItem methoid is activated
    alcRemove = 3   ' RemoveItem method is activated
    alcSort = 4     ' Refresh sorted the array
End Enum

' Local variable(s) to hold property value(s)
Private mvarList As Variant             ' The array

Private mvarCount As Integer
Private mvarSort As ArrayListSortMode   ' Sort mode

' ArrayList events
Public Event Change(ByVal alcReason As ArrayListChangeReason)

Public Property Get Count() As Integer
    ' Return the size of the array
    mvarCount = UBound(mvarList) + 1
    Count = mvarCount
End Property

Public Property Set List(ByVal vList As Variant)
Attribute List.VB_UserMemId = 0
    ' Set the new array for the object
    mvarList = vList
End Property
Public Property Get List() As Variant
    ' Return a reference to the array
    List = mvarList
End Property

Public Property Let Sort(ByVal vData As ArrayListSortMode)
    ' Set the sort mode
    mvarSort = vData
    ' Refresh must be explicitly called for the sort to take effect
End Property
Public Property Get Sort() As ArrayListSortMode
    ' Return the current sort mode
    Sort = mvarSort
End Property

Public Sub AddItem(ByVal Item As Variant)
    ' Add an item to the array
    AAddItem mvarList, Item
    RaiseEvent Change(alcAdd)
End Sub

Public Sub Clear()
Attribute Clear.VB_Description = "Clears the ArrayList."
    ' Clear the array
    AClear mvarList
    RaiseEvent Change(alcClear)
End Sub

Public Sub InsertItem(ByVal Item As Variant, ByVal Key As Integer)
Attribute InsertItem.VB_Description = "Insert an item in the ArrayList at a given key location."
    ' Insert an item to the array
    AInsertItem mvarList, Item, Key
    RaiseEvent Change(alcInsert)
End Sub

Public Function IsInArrayList(ByVal Item As Variant) As Boolean
    ' Determine the existence of an item in the array
    IsInArrayList = AIsInArray(mvarList, Item)
End Function

Public Sub Refresh()
    ' Apply changes by sorting the array
    If mvarSort <> alsNoSortMode Then
        ASort mvarList, IIf(mvarSort = alsSortAscend, False, True)
        RaiseEvent Change(alcSort)
    End If
    ' Note that Refresh cannot unsort a sorted array
End Sub

Public Sub RemoveItem(ByVal Item As Variant)
Attribute RemoveItem.VB_Description = "Remove an item from the ArrayList."
    ' Remove an item from the array
    ARemoveItem mvarList, Item
    RaiseEvent Change(alcRemove)
End Sub

Public Sub RemoveKey(ByVal Key As Integer)
    ' Remove an item from the array via its key
    ARemoveKey mvarList, Key
    RaiseEvent Change(alcRemove)
End Sub

Public Sub ReSize(Optional ByVal intUpDown As Integer = 1, Optional boolClear As Boolean)
    ' Resize the list's array list without adding any item value
    ' A negative intUpDown number decreases the size of the array
    AResize mvarList, mvarCount + intUpDown, boolClear
End Sub

Private Sub Class_Initialize()
    mvarList = Array()
End Sub
